diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-emlsr-enabling-test.cc ns-3.45/src/wifi/test/wifi-emlsr-enabling-test.cc
--- ns-3.44/src/wifi/test/wifi-emlsr-enabling-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/wifi/test/wifi-emlsr-enabling-test.cc	2025-06-01 20:34:45.636702300 -0700
@@ -0,0 +1,361 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "wifi-emlsr-enabling-test.h"
+
+#include "ns3/advanced-emlsr-manager.h"
+#include "ns3/boolean.h"
+#include "ns3/config.h"
+#include "ns3/ctrl-headers.h"
+#include "ns3/log.h"
+#include "ns3/mgt-action-headers.h"
+#include "ns3/qos-txop.h"
+#include "ns3/simulator.h"
+#include "ns3/string.h"
+#include "ns3/wifi-net-device.h"
+#include "ns3/wifi-phy.h"
+
+#include <algorithm>
+#include <functional>
+#include <iomanip>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("WifiEmlsrEnablingTest");
+
+EmlOperatingModeNotificationTest::EmlOperatingModeNotificationTest()
+    : HeaderSerializationTestCase(
+          "Check serialization and deserialization of the EML Operating Mode Notification frame")
+{
+}
+
+void
+EmlOperatingModeNotificationTest::DoRun()
+{
+    MgtEmlOmn frame;
+
+    // Both EMLSR Mode and EMLMR Mode subfields set to 0 (no link bitmap);
+    TestHeaderSerialization(frame);
+
+    frame.m_emlControl.emlsrMode = 1;
+    frame.SetLinkIdInBitmap(0);
+    frame.SetLinkIdInBitmap(5);
+    frame.SetLinkIdInBitmap(15);
+
+    // Adding Link Bitmap
+    TestHeaderSerialization(frame);
+
+    NS_TEST_EXPECT_MSG_EQ((frame.GetLinkBitmap() == std::list<uint8_t>{0, 5, 15}),
+                          true,
+                          "Unexpected link bitmap");
+
+    auto padding = MicroSeconds(64);
+    auto transition = MicroSeconds(128);
+
+    frame.m_emlControl.emlsrParamUpdateCtrl = 1;
+    frame.m_emlsrParamUpdate = MgtEmlOmn::EmlsrParamUpdate{};
+    frame.m_emlsrParamUpdate->paddingDelay = CommonInfoBasicMle::EncodeEmlsrPaddingDelay(padding);
+    frame.m_emlsrParamUpdate->transitionDelay =
+        CommonInfoBasicMle::EncodeEmlsrTransitionDelay(transition);
+
+    // Adding the EMLSR Parameter Update field
+    TestHeaderSerialization(frame);
+
+    NS_TEST_EXPECT_MSG_EQ(
+        CommonInfoBasicMle::DecodeEmlsrPaddingDelay(frame.m_emlsrParamUpdate->paddingDelay),
+        padding,
+        "Unexpected EMLSR Padding Delay");
+    NS_TEST_EXPECT_MSG_EQ(
+        CommonInfoBasicMle::DecodeEmlsrTransitionDelay(frame.m_emlsrParamUpdate->transitionDelay),
+        transition,
+        "Unexpected EMLSR Transition Delay");
+}
+
+EmlOmnExchangeTest::EmlOmnExchangeTest(const std::set<uint8_t>& linksToEnableEmlsrOn,
+                                       Time transitionTimeout)
+    : EmlsrOperationsTestBase("Check EML Notification exchange"),
+      m_checkEmlsrLinksCount(0),
+      m_emlNotificationDroppedCount(0)
+{
+    m_linksToEnableEmlsrOn = linksToEnableEmlsrOn;
+    m_nEmlsrStations = 1;
+    m_nNonEmlsrStations = 0;
+    m_transitionTimeout = transitionTimeout;
+    m_duration = Seconds(0.5);
+}
+
+void
+EmlOmnExchangeTest::DoSetup()
+{
+    EmlsrOperationsTestBase::DoSetup();
+
+    m_errorModel = CreateObject<ListErrorModel>();
+    for (std::size_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
+    {
+        m_apMac->GetWifiPhy(linkId)->SetPostReceptionErrorModel(m_errorModel);
+    }
+
+    m_staMacs[0]->TraceConnectWithoutContext("AckedMpdu",
+                                             MakeCallback(&EmlOmnExchangeTest::TxOk, this));
+    m_staMacs[0]->TraceConnectWithoutContext("DroppedMpdu",
+                                             MakeCallback(&EmlOmnExchangeTest::TxDropped, this));
+}
+
+void
+EmlOmnExchangeTest::Transmit(Ptr<WifiMac> mac,
+                             uint8_t phyId,
+                             WifiConstPsduMap psduMap,
+                             WifiTxVector txVector,
+                             double txPowerW)
+{
+    EmlsrOperationsTestBase::Transmit(mac, phyId, psduMap, txVector, txPowerW);
+    auto linkId = m_txPsdus.back().linkId;
+
+    auto psdu = psduMap.begin()->second;
+
+    switch (psdu->GetHeader(0).GetType())
+    {
+    case WIFI_MAC_MGT_ASSOCIATION_REQUEST:
+        NS_TEST_EXPECT_MSG_EQ(+linkId, +m_mainPhyId, "AssocReq not sent by the main PHY");
+        CheckEmlCapabilitiesInAssocReq(*psdu->begin(), txVector, linkId);
+        break;
+
+    case WIFI_MAC_MGT_ASSOCIATION_RESPONSE:
+        CheckEmlCapabilitiesInAssocResp(*psdu->begin(), txVector, linkId);
+        break;
+
+    case WIFI_MAC_MGT_ACTION:
+        if (auto [category, action] = WifiActionHeader::Peek(psdu->GetPayload(0));
+            category == WifiActionHeader::PROTECTED_EHT &&
+            action.protectedEhtAction ==
+                WifiActionHeader::PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION)
+        {
+            CheckEmlNotification(psdu, txVector, linkId);
+
+            if (m_emlNotificationDroppedCount == 0 &&
+                m_staMacs[0]->GetLinkIdByAddress(psdu->GetAddr2()) == linkId)
+            {
+                // transmitted by non-AP MLD, we need to corrupt it
+                m_uidList.push_front(psdu->GetPacket()->GetUid());
+                m_errorModel->SetList(m_uidList);
+            }
+            break;
+        }
+
+    default:;
+    }
+}
+
+void
+EmlOmnExchangeTest::CheckEmlCapabilitiesInAssocReq(Ptr<const WifiMpdu> mpdu,
+                                                   const WifiTxVector& txVector,
+                                                   uint8_t linkId)
+{
+    MgtAssocRequestHeader frame;
+    mpdu->GetPacket()->PeekHeader(frame);
+
+    const auto& mle = frame.Get<MultiLinkElement>();
+    NS_TEST_ASSERT_MSG_EQ(mle.has_value(), true, "Multi-Link Element must be present in AssocReq");
+
+    NS_TEST_ASSERT_MSG_EQ(mle->HasEmlCapabilities(),
+                          true,
+                          "Multi-Link Element in AssocReq must have EML Capabilities");
+    NS_TEST_ASSERT_MSG_EQ(mle->IsEmlsrSupported(),
+                          true,
+                          "EML Support subfield of EML Capabilities in AssocReq must be set to 1");
+    NS_TEST_ASSERT_MSG_EQ(mle->GetEmlsrPaddingDelay(),
+                          m_paddingDelay.at(0),
+                          "Unexpected Padding Delay in EML Capabilities included in AssocReq");
+    NS_TEST_ASSERT_MSG_EQ(mle->GetEmlsrTransitionDelay(),
+                          m_transitionDelay.at(0),
+                          "Unexpected Transition Delay in EML Capabilities included in AssocReq");
+}
+
+void
+EmlOmnExchangeTest::CheckEmlCapabilitiesInAssocResp(Ptr<const WifiMpdu> mpdu,
+                                                    const WifiTxVector& txVector,
+                                                    uint8_t linkId)
+{
+    bool sentToEmlsrClient =
+        (m_staMacs[0]->GetLinkIdByAddress(mpdu->GetHeader().GetAddr1()) == linkId);
+
+    if (!sentToEmlsrClient)
+    {
+        // nothing to check
+        return;
+    }
+
+    MgtAssocResponseHeader frame;
+    mpdu->GetPacket()->PeekHeader(frame);
+
+    const auto& mle = frame.Get<MultiLinkElement>();
+    NS_TEST_ASSERT_MSG_EQ(mle.has_value(), true, "Multi-Link Element must be present in AssocResp");
+
+    NS_TEST_ASSERT_MSG_EQ(mle->HasEmlCapabilities(),
+                          true,
+                          "Multi-Link Element in AssocResp must have EML Capabilities");
+    NS_TEST_ASSERT_MSG_EQ(mle->IsEmlsrSupported(),
+                          true,
+                          "EML Support subfield of EML Capabilities in AssocResp must be set to 1");
+    NS_TEST_ASSERT_MSG_EQ(
+        mle->GetTransitionTimeout(),
+        m_transitionTimeout,
+        "Unexpected Transition Timeout in EML Capabilities included in AssocResp");
+}
+
+void
+EmlOmnExchangeTest::CheckEmlNotification(Ptr<const WifiPsdu> psdu,
+                                         const WifiTxVector& txVector,
+                                         uint8_t linkId)
+{
+    MgtEmlOmn frame;
+    auto mpdu = *psdu->begin();
+    auto pkt = mpdu->GetPacket()->Copy();
+    WifiActionHeader::Remove(pkt);
+    pkt->RemoveHeader(frame);
+    NS_LOG_DEBUG(frame);
+
+    bool sentbyNonApMld = m_staMacs[0]->GetLinkIdByAddress(mpdu->GetHeader().GetAddr2()) == linkId;
+
+    NS_TEST_EXPECT_MSG_EQ(+frame.m_emlControl.emlsrMode,
+                          1,
+                          "EMLSR Mode subfield should be set to 1 (frame sent by non-AP MLD: "
+                              << std::boolalpha << sentbyNonApMld << ")");
+
+    NS_TEST_EXPECT_MSG_EQ(+frame.m_emlControl.emlmrMode,
+                          0,
+                          "EMLMR Mode subfield should be set to 0 (frame sent by non-AP MLD: "
+                              << std::boolalpha << sentbyNonApMld << ")");
+
+    NS_TEST_ASSERT_MSG_EQ(frame.m_emlControl.linkBitmap.has_value(),
+                          true,
+                          "Link Bitmap subfield should be present (frame sent by non-AP MLD: "
+                              << std::boolalpha << sentbyNonApMld << ")");
+
+    auto setupLinks = m_staMacs[0]->GetSetupLinkIds();
+    std::list<uint8_t> expectedEmlsrLinks;
+    std::set_intersection(setupLinks.begin(),
+                          setupLinks.end(),
+                          m_linksToEnableEmlsrOn.begin(),
+                          m_linksToEnableEmlsrOn.end(),
+                          std::back_inserter(expectedEmlsrLinks));
+
+    NS_TEST_EXPECT_MSG_EQ((expectedEmlsrLinks == frame.GetLinkBitmap()),
+                          true,
+                          "Unexpected Link Bitmap subfield (frame sent by non-AP MLD: "
+                              << std::boolalpha << sentbyNonApMld << ")");
+
+    if (!sentbyNonApMld)
+    {
+        // the frame has been sent by the AP MLD
+        NS_TEST_ASSERT_MSG_EQ(
+            +frame.m_emlControl.emlsrParamUpdateCtrl,
+            0,
+            "EMLSR Parameter Update Control should be set to 0 in frames sent by the AP MLD");
+
+        // as soon as the non-AP MLD receives this frame, it sets the EMLSR links
+        auto delay = WifiPhy::CalculateTxDuration(psdu,
+                                                  txVector,
+                                                  m_staMacs[0]->GetWifiPhy(linkId)->GetPhyBand()) +
+                     MicroSeconds(1); // to account for propagation delay
+        Simulator::Schedule(delay, &EmlOmnExchangeTest::CheckEmlsrLinks, this);
+    }
+
+    NS_TEST_EXPECT_MSG_EQ(+m_mainPhyId,
+                          +linkId,
+                          "EML Notification received on unexpected link (frame sent by non-AP MLD: "
+                              << std::boolalpha << sentbyNonApMld << ")");
+}
+
+void
+EmlOmnExchangeTest::TxOk(Ptr<const WifiMpdu> mpdu)
+{
+    const auto& hdr = mpdu->GetHeader();
+
+    if (hdr.IsMgt() && hdr.IsAction())
+    {
+        if (auto [category, action] = WifiActionHeader::Peek(mpdu->GetPacket());
+            category == WifiActionHeader::PROTECTED_EHT &&
+            action.protectedEhtAction ==
+                WifiActionHeader::PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION)
+        {
+            // the EML Operating Mode Notification frame that the non-AP MLD sent has been
+            // acknowledged; after the transition timeout, the EMLSR links have been set
+            Simulator::Schedule(m_transitionTimeout + NanoSeconds(1),
+                                &EmlOmnExchangeTest::CheckEmlsrLinks,
+                                this);
+        }
+    }
+}
+
+void
+EmlOmnExchangeTest::TxDropped(WifiMacDropReason reason, Ptr<const WifiMpdu> mpdu)
+{
+    const auto& hdr = mpdu->GetHeader();
+
+    if (hdr.IsMgt() && hdr.IsAction())
+    {
+        if (auto [category, action] = WifiActionHeader::Peek(mpdu->GetPacket());
+            category == WifiActionHeader::PROTECTED_EHT &&
+            action.protectedEhtAction ==
+                WifiActionHeader::PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION)
+        {
+            // the EML Operating Mode Notification frame has been dropped. Don't
+            // corrupt it anymore
+            m_emlNotificationDroppedCount++;
+        }
+    }
+}
+
+void
+EmlOmnExchangeTest::CheckEmlsrLinks()
+{
+    m_checkEmlsrLinksCount++;
+
+    auto setupLinks = m_staMacs[0]->GetSetupLinkIds();
+    std::set<uint8_t> expectedEmlsrLinks;
+    std::set_intersection(setupLinks.begin(),
+                          setupLinks.end(),
+                          m_linksToEnableEmlsrOn.begin(),
+                          m_linksToEnableEmlsrOn.end(),
+                          std::inserter(expectedEmlsrLinks, expectedEmlsrLinks.end()));
+
+    NS_TEST_EXPECT_MSG_EQ((expectedEmlsrLinks == m_staMacs[0]->GetEmlsrManager()->GetEmlsrLinks()),
+                          true,
+                          "Unexpected set of EMLSR links)");
+}
+
+void
+EmlOmnExchangeTest::DoRun()
+{
+    Simulator::Stop(m_duration);
+    Simulator::Run();
+
+    NS_TEST_EXPECT_MSG_EQ(m_checkEmlsrLinksCount,
+                          2,
+                          "Unexpected number of times CheckEmlsrLinks() is called");
+    NS_TEST_EXPECT_MSG_EQ(
+        m_emlNotificationDroppedCount,
+        1,
+        "Unexpected number of times the EML Notification frame is dropped due to max retry limit");
+
+    Simulator::Destroy();
+}
+
+WifiEmlsrEnablingTestSuite::WifiEmlsrEnablingTestSuite()
+    : TestSuite("wifi-emlsr-enabling", Type::UNIT)
+{
+    AddTestCase(new EmlOperatingModeNotificationTest(), TestCase::Duration::QUICK);
+    AddTestCase(new EmlOmnExchangeTest({1, 2}, MicroSeconds(0)), TestCase::Duration::QUICK);
+    AddTestCase(new EmlOmnExchangeTest({1, 2}, MicroSeconds(2048)), TestCase::Duration::QUICK);
+    AddTestCase(new EmlOmnExchangeTest({0, 1, 2, 3}, MicroSeconds(0)), TestCase::Duration::QUICK);
+    AddTestCase(new EmlOmnExchangeTest({0, 1, 2, 3}, MicroSeconds(2048)),
+                TestCase::Duration::QUICK);
+}
+
+static WifiEmlsrEnablingTestSuite g_wifiEmlsrEnablingTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-emlsr-enabling-test.h ns-3.45/src/wifi/test/wifi-emlsr-enabling-test.h
--- ns-3.44/src/wifi/test/wifi-emlsr-enabling-test.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/wifi/test/wifi-emlsr-enabling-test.h	2025-06-01 20:34:45.636702300 -0700
@@ -0,0 +1,153 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WIFI_EMLSR_ENABLING_TEST_H
+#define WIFI_EMLSR_ENABLING_TEST_H
+
+#include "wifi-emlsr-test-base.h"
+
+#include <list>
+
+/**
+ * @ingroup wifi-test
+ * @ingroup tests
+ *
+ * @brief Test EML Operating Mode Notification frame serialization and deserialization
+ */
+class EmlOperatingModeNotificationTest : public HeaderSerializationTestCase
+{
+  public:
+    /**
+     * Constructor
+     */
+    EmlOperatingModeNotificationTest();
+    ~EmlOperatingModeNotificationTest() override = default;
+
+  private:
+    void DoRun() override;
+};
+
+/**
+ * @ingroup wifi-test
+ * @ingroup tests
+ *
+ * @brief Test the exchange of EML Operating Mode Notification frames.
+ *
+ * This test considers an AP MLD and a non-AP MLD with EMLSR activated. Upon association,
+ * the non-AP MLD sends an EML Operating Mode Notification frame, which is however corrupted
+ * by using a post reception error model (installed on the AP MLD). We keep corrupting the
+ * EML Notification frames transmitted by the non-AP MLD until the frame is dropped due to
+ * exceeded max retry limit. It is checked that:
+ *
+ * - the Association Request contains a Multi-Link Element including an EML Capabilities field
+ *   that contains the expected values for Padding Delay and Transition Delay
+ * - the Association Response contains a Multi-Link Element including an EML Capabilities field
+ *   that contains the expected value for Transition Timeout
+ * - all EML Notification frames contain the expected values for EMLSR Mode, EMLMR Mode and
+ *   Link Bitmap fields and are transmitted on the link used for association
+ * - the correct EMLSR link set is stored by the EMLSR Manager, both when the transition
+ *   timeout expires and when an EML Notification response is received from the AP MLD (thus,
+ *   the correct EMLSR link set is stored after whichever of the two events occur first)
+ */
+class EmlOmnExchangeTest : public EmlsrOperationsTestBase
+{
+  public:
+    /**
+     * Constructor
+     *
+     * @param linksToEnableEmlsrOn IDs of links on which EMLSR mode should be enabled
+     * @param transitionTimeout the Transition Timeout advertised by the AP MLD
+     */
+    EmlOmnExchangeTest(const std::set<uint8_t>& linksToEnableEmlsrOn, Time transitionTimeout);
+    ~EmlOmnExchangeTest() override = default;
+
+  protected:
+    void DoSetup() override;
+    void DoRun() override;
+    void Transmit(Ptr<WifiMac> mac,
+                  uint8_t phyId,
+                  WifiConstPsduMap psduMap,
+                  WifiTxVector txVector,
+                  double txPowerW) override;
+
+    /**
+     * Callback invoked when the non-AP MLD receives the acknowledgment for a transmitted MPDU.
+     *
+     * @param mpdu the acknowledged MPDU
+     */
+    void TxOk(Ptr<const WifiMpdu> mpdu);
+    /**
+     * Callback invoked when the non-AP MLD drops the given MPDU for the given reason.
+     *
+     * @param reason the reason why the MPDU was dropped
+     * @param mpdu the dropped MPDU
+     */
+    void TxDropped(WifiMacDropReason reason, Ptr<const WifiMpdu> mpdu);
+
+    /**
+     * Check the content of the EML Capabilities subfield of the Multi-Link Element included
+     * in the Association Request frame sent by the non-AP MLD.
+     *
+     * @param mpdu the MPDU containing the Association Request frame
+     * @param txVector the TXVECTOR used to transmit the frame
+     * @param linkId the ID of the link on which the frame was transmitted
+     */
+    void CheckEmlCapabilitiesInAssocReq(Ptr<const WifiMpdu> mpdu,
+                                        const WifiTxVector& txVector,
+                                        uint8_t linkId);
+    /**
+     * Check the content of the EML Capabilities subfield of the Multi-Link Element included
+     * in the Association Response frame sent by the AP MLD to the EMLSR client.
+     *
+     * @param mpdu the MPDU containing the Association Response frame
+     * @param txVector the TXVECTOR used to transmit the frame
+     * @param linkId the ID of the link on which the frame was transmitted
+     */
+    void CheckEmlCapabilitiesInAssocResp(Ptr<const WifiMpdu> mpdu,
+                                         const WifiTxVector& txVector,
+                                         uint8_t linkId);
+    /**
+     * Check the content of a received EML Operating Mode Notification frame.
+     *
+     * @param psdu the PSDU containing the EML Operating Mode Notification frame
+     * @param txVector the TXVECTOR used to transmit the frame
+     * @param linkId the ID of the link on which the frame was transmitted
+     */
+    void CheckEmlNotification(Ptr<const WifiPsdu> psdu,
+                              const WifiTxVector& txVector,
+                              uint8_t linkId);
+    /**
+     * Check that the EMLSR mode has been enabled on the expected EMLSR links.
+     */
+    void CheckEmlsrLinks();
+
+  private:
+    std::size_t m_checkEmlsrLinksCount;        /**< counter for the number of times CheckEmlsrLinks
+                                                    is called (should be two: when the transition
+                                                    timeout expires and when the EML Notification
+                                                    response from the AP MLD is received */
+    std::size_t m_emlNotificationDroppedCount; /**< counter for the number of times the EML
+                                                    Notification frame sent by the non-AP MLD
+                                                    has been dropped due to max retry limit */
+    Ptr<ListErrorModel> m_errorModel;          ///< error rate model to corrupt packets at AP MLD
+    std::list<uint64_t> m_uidList;             ///< list of UIDs of packets to corrupt
+};
+
+/**
+ * @ingroup wifi-test
+ * @ingroup tests
+ *
+ * @brief wifi EMLSR suite to test the procedure for enabling EMLSR mode
+ */
+class WifiEmlsrEnablingTestSuite : public TestSuite
+{
+  public:
+    WifiEmlsrEnablingTestSuite();
+};
+
+#endif /* WIFI_EMLSR_ENABLING_TEST_H */
